# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import waptlicences

def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    base_url = "https://winscp.net/eng/download.php"

    # Getting latest version from official sources
    print(f"URL used is: {base_url}")
    for link in bs_find_all(base_url, "a", proxies=proxies):
        href = link.get('href', '')
        if ("WinSCP-" and "-Setup.exe") in href:
            url = "https://winscp.net" + href
            latest_bin = url.rsplit("/")[-2]
            latest_bin_extension = latest_bin.rsplit(".")[-1]
            version = latest_bin.split("-")[1]
            break

    for link in bs_find_all(url, "a", proxies=proxies):
        if latest_bin in link['href']:
            download_url = link['href']
            break

    # Downloading latest binaries
    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    expected_issuer = "Martin Prikryl"
    sign_name = waptlicences.check_exe_signing_certificate(latest_bin)[0]
    if sign_name != expected_issuer:
        error(f'Bad issuer {sign_name} != {expected_issuer}')

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))

    #nettoyer les fichiers temporaires
    for f in glob.glob(f'*.{latest_bin_extension}'):
        if f != latest_bin:
            remove_file(f)

    control.set_software_version(get_version_from_binary(latest_bin))
    control.save_control_to_wapt()

    return package_updated